[retour au README.md](../../../README.md)  
[Retour aux Documents](../../README_DOCUMENTS.md)

```plantuml
@startuml issue028_DiagrammeDeClasses
class Activite {
    -idActivite:int
    -type:String
    -date:Date
    -heureDebut:Date
    -heureFin:Date
    -effortRessenti:int
    -variability:float
    -variance:float
    -standardDeviation:float
    -average:float
    -maximum:int
    -minimum:int
    -avrTemperature:float
    -hasAutoPause:boolean
    +getIdActivite():int
    +getType():String
    +getDate():Date
    +getHeureDebut():Date
    +getHeureFin():Date
    +getEffortRessenti():int
    +getVariability():float
    +getVariance():float
    +getStandardDeviation():float
    +getAverage():float
    +getMaximum():int
    +getMinimum():int
    +getAvrTemperature():float
    +setType(type:String):void
    +setEffortRessenti(effortRessenti:int):void
    +__toString():String
}
class Role {
    -id:int
}
class Athlete {
    +getActivities():array
    +addActivity(myActivity:Activity):boolean
}
class User {
    -id:int
    -username:String
    -nom:String
    -prenom:String
    -email:String
    -motDePasse:String
    -sexe:String
    -taille:float
    -poids:float
    -dateNaissance:Date
    +getId():int
    +setId(id:int):void
    +getUsername():String
    +setUsername(username:String):void
    +getNom():String
    +setNom(nom:String):void
    +getPrenom():String
    +setPrenom(prenom:String):void
    +getEmail():String
    +setEmail(email:String):void
    +getMotDePasse():String
    +setMotDePasse(motDePasse:String):void
    +getSexe():String
    +setSexe(sexe:String):void
    +getTaille():float
    +setTaille(taille:float):void
    +getPoids():float
    +setPoids(poids:float):void
    +getDateNaissance():Date
    +setDateNaissance(dateNaissance:Date):void
    +getRole():Role
    +setRole(role:Role):void
    +isValidPassword(password:String):boolean
    +__toString():String
}
class AthleteManager {
    +getActivities():array
}
class ActivityManager {
    +saveFitFileToJSON(monFichierFit:object):boolean
    +uploadFile(type:string, effortRessenti:int, file_path_or_data:string|resource, options:array):boolean
}
class DataManager {
}
class UserManager {
    +login(loginUser:string, passwordUser:string):boolean
    +register(loginUser:string, passwordUser:string, data:array):boolean
    +deconnecter():boolean
}

User -> Role: role
Athlete -|> Role
DataManager -> UserManager: -userMgr
DataManager -> AthleteManager: -athleteMgr
DataManager -> ActivityManager: -activityMgr
UserManager -> AuthService: -authService
UserManager -> User: -currentUser
ActivityManager -> AuthService: -authService
Athlete -> Activite: listActivite
AthleteManager -> AuthService: -authService
@enduml
```